program STI_SDEM;

uses CRT,
     STI_SCRF;

Var
  SavedWindow  : WindowSave;
  Borders      : array[1..6] of string[8];
  Inch         : char;

{---------------------------------------------------------------------------}

procedure Explain;

Var
  Inch : char;

begin
  writeln('                              STI_SDEM');
  writeln('');
  writeln('           A demostration of the STI_SCRF procedures and the');
  writeln('           kind of screen they produce. ESC ends the demo.');
  writeln('');
  writeln('           Press any key to continue...');
  repeat until keypressed;
  Inch := ReadKey;
end;

{---------------------------------------------------------------------------}

procedure RandomText;

Var
  Loop : word;

begin
  for Loop := 1 to 1000 do
    write(char(random(200)+32));
end;

{---------------------------------------------------------------------------}

begin
  ClrScr;
  Explain;
  RandomText;
  Borders[1] := SINGLELINE;
  Borders[2] := ROUNDCORNERSINGLE;
  Borders[3] := BIGBLOCK;
  Borders[4] := THICKTOPTHINSIDES;
  Borders[5] := THICKDIAGONALCORNER;
  Borders[6] := SPACES;
  repeat
    MakeWindow(SavedWindow,
               random(30)+1,
               random(10)+1,
               random(30)+40,
               random(10)+13,
               White,
               Green,
               Yellow+Reverse,
               Borders[random(5)+1],
               'Test');
    Inch := ReadKey;
    DisposeWindow(SavedWindow);
  until Inch = #27;
  ClrScr;
end.